/******************************************************************************
 *
 * Copyright (c) 2004 PalmSpace/Sembe.
 *				All rights reserved.
 *
 * File: PsLinkLib.h
 *
 * History:
 *		Dec 18, 2004	Created by sembe
 *
 *****************************************************************************/

#ifndef _PSLINKLIB_H_
#define _PSLINKLIB_H_


/***********************************************************************
 *
 *	Internal Structures
 *
 ***********************************************************************/
typedef struct {
   WChar          chr;
   UInt16         keyCode;
   UInt16         modifiers;
} KeyDownEventDataType;

typedef struct {
	UInt32			state : 1;
	UInt32			singleTap : 1;
	UInt32			autoEnble : 1;
	UInt32			ignoreBtn : 1;
	UInt32			caseSensitive : 1;
	UInt32			partOfTitle : 1;
	UInt32			reserved1 : 10;
	UInt32			memoWikiName : 1;
	UInt32			todoCompleted : 1;
	UInt32			reserved2 : 14;

	UInt32			creator[NUM_LINK_APPS];	//memo, address, date, web, mail, etc.
	Char			dbName[NUM_LINK_APPS][dmDBNameLength];
	Char			tag[NUM_LINK_APPS][2][MAXLEN_TAG + 1];

	Char			linkChrBookmark;
	Char			linkChrDBname;

	Boolean			dbLink[NUM_LINK_APPS];
	Char			dbPrefix[NUM_LINK_APPS][MAXLEN_PREFIX + 1];

	KeyDownEventDataType	backKey;
	KeyDownEventDataType	forwardKey;
} PsLinkPreferenceType;


/***********************************************************************
 *
 * Function Prototypes
 *
 ***********************************************************************/
void	*GetObjectPtr (UInt16 objectID);
Boolean FindStr (Char *s1, Char *s2, Boolean caseSensitive, Boolean part);
Boolean GetApplName (UInt16 cardNo, LocalID dbID, Char *name);

void	GetPreferences (PsLinkPreferenceType *prefs);
void	SetPreferences (PsLinkPreferenceType *prefs);

Boolean	CheckDBOpenByCreator (DmOpenRef *dbP, UInt32 dbType, UInt32 dbCreator, Boolean force);
Boolean	CheckDBOpenByID (DmOpenRef *dbP, UInt16 mCardNo, LocalID mdbID, Boolean force);
Boolean	CheckDBOpenByName (DmOpenRef *dbP, Char *dbName, Boolean force);
Boolean	FindRecordByString (DmOpenRef dbP, Char *string, UInt16 *recordNum);
Boolean	GetBusyRecordID (DmOpenRef dbP, UInt32 *uniqueIDP);

Err		SwitchApp (UInt16 appCardNo, LocalID appID,
 Int16 searchStrLen, UInt16 dbCardNo, LocalID dbID,
 UInt16 recordNum, UInt16 matchPos, UInt16 matchFieldNum, UInt32 matchCustom);


#endif //_PSLINKLIB_H_
